<script setup lang="ts">
import type { Promotion } from '@/types/Promotion'
import { ref, nextTick, computed, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'
import { usePromotionStore } from '@/stores/promotion'
import promotion from '@/service/promotion'
import PromotionDialog from './PromotionDialog.vue'
import { useProductStore } from '@/stores/product'

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const PromotionStore = usePromotionStore()
const productStore = useProductStore()
const page = ref(1)
const itemsPerPage = ref<any>(5)
const search = ref<string>('')
const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Image',
    key: 'image'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Condition',
    key: 'condition'
  },
  {
    title: ' Member',
    key: 'member'
  },
  {
    title: 'PercentDiscount',
    key: 'percentDiscount'
  },
  {
    title: 'PriceDiscount',
    key: 'priceDiscount'
  },
  {
    title: 'MinQty',
    key: 'minQty'
  },
  {
    title: 'MinPrice',
    key: 'minPrice'
  },
  {
    title: 'start_date',
    key: 'start_date'
  },
  {
    title: 'end_date',
    key: 'end_date'
  },
  { title: '', key: 'actions', sortable: false }
]

let editedIndex = -1

function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    PromotionStore.clearForm()
  })
}

async function deleteItemConfirm() {
  closeDelete()
  console.log(promotion)
  await PromotionStore.deletePromotion()
}

const pageCount = computed(() => {
  return Math.ceil(PromotionStore.promotions.length / itemsPerPage.value)
})

async function deleteItem(item: Promotion) {
  if (!item.id) return
  await PromotionStore.getPromotion(item.id!)
  dialogDelete.value = true
  editedIndex = -1
}

async function editItem(item: Promotion) {
  console.log(item)
  await PromotionStore.getPromotion(item.id!)
  dialog.value = true
}

function closeDialog() {
  console.log(productStore.products)
  dialog.value = false
  nextTick(() => {
    PromotionStore.clearForm()
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  closeDialog()
  await PromotionStore.savePromotion()
}

const formattedEmployees = computed(() =>
  PromotionStore.promotions.map((Promotion) => ({ ...Promotion }))
)

const filteredPromotion = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedEmployees.value.filter((promotions) =>
    promotions.name.toLowerCase().includes(searchLower)
  )
})

onMounted(async () => {
  await PromotionStore.getPromotions()
})
</script>

<template>
  <div>
    <div class="ml-5">
      <!-- Data -->
      <div class="text-center">
        <h1 style="text-align: left; font-size: 50px;"><v-icon icon="mdi mdi-account" class="mr-2"></v-icon>Promotion
        </h1>
      </div>
      <v-row>
        <v-col cols="6">
          <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line
            flat hide-details variant="solo-filled"></v-text-field>
        </v-col>
        <v-col cols="6">
          <!-- new employee -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="success" v-bind="props" style="font-family: 'Kanit'">New Promotion</v-btn>
            </template>
            <v-card title="Promotion Detail" class="pt-6" style="text-align: center">
              <v-card-title color="blue"><v-card-text>
                  <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="PromotionStore.editedPromotion.name" :readonly="loading"
                            :rules="[(v: any) => !!v || 'Field is required']" class="mb-2" clearable label="Name"
                            placeholder="Enter Promotion Name" variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-select v-model="PromotionStore.editedPromotion.condition" :readonly="loading"
                            :rules="[(v: any) => !!v || 'Field is required']"
                            :items="['priceDiscount', 'percentDiscount']" label="Condition" variant="outlined">
                          </v-select>
                        </v-col>

                        <v-col cols="12" sm="12" md="4"
                          v-if="PromotionStore.editedPromotion.condition === 'priceDiscount'">
                          <v-text-field v-model="PromotionStore.editedPromotion.priceDiscount" :readonly="loading"
                            :rules="[
            (v: any) => !!v || 'Field is required',
            (v: string) => /^\d+$/.test(v) || 'must contain only digits'
          ]" clearable label="Price Discount" placeholder="Enter your Price Discount"
                            variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4"
                          v-if="PromotionStore.editedPromotion.condition === 'percentDiscount'">
                          <v-text-field v-model="PromotionStore.editedPromotion.percentDiscount" :readonly="loading"
                            :rules="[
            (v: any) => !!v || 'Field is required',
            (v: string) => /^\d+$/.test(v) || 'must contain only digits'
          ]" clearable label="Percent Discount" placeholder="Enter your Percent Discount"
                            variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="PromotionStore.editedPromotion.minQty" :readonly="loading" :rules="[
            (v: any) => !!v || 'Field is required',
            (v: string) => /^\d+$/.test(v) || 'must contain only digits'
          ]" clearable label="minQty" placeholder="Enter your minQty"
                            variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="PromotionStore.editedPromotion.minPrice" :readonly="loading" :rules="[
            (v: any) => !!v || 'Field is required',
            (v: string) => /^\d+$/.test(v) || 'must contain only digits'
          ]" clearable label="minPrice" placeholder="Enter your minPrice"
                            variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="PromotionStore.editedPromotion.start_date" :readonly="loading"
                            :rules="[(v: any) => !!v || 'Field is required']" clearable label="start_date"
                            placeholder="Enter your start_date" type="date" variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="PromotionStore.editedPromotion.end_date" :readonly="loading"
                            :rules="[(v: any) => !!v || 'Field is required']" clearable label="end_date"
                            placeholder="Enter your end_date" type="date" variant="outlined"></v-text-field>
                        </v-col>

                        <v-col>
                          <v-checkbox v-model="PromotionStore.editedPromotion.member" color="success" label="member"
                            hide-details></v-checkbox>
                        </v-col>

                        <v-col cols="12" sm="12" md="6">
                          <v-file-input v-model="PromotionStore.editedPromotion.files" variant="outlined" :rules="[
            (value: string | any[]) => {
              return (
                !value ||
                !value.length ||
                value[0].size < 2000000 ||
                'Image size should be less than 2 MB!'
              )
            }
          ]" accept="image/png, image/jpeg, image/bmp" label="Image" placeholder="Pick an avatar"
                            prepend-icon="mdi-camera"></v-file-input>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form> </v-card-text></v-card-title>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn style="width: 200px; height: 60px" variant="flat" @click="closeDialog()" class="ms-5"
                  color="red">Cancel</v-btn>
                <v-btn style="width: 200px; height: 60px" variant="flat" color="success" @click="save()" class="ms-10">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-col>
      </v-row>
      <v-dialog v-model="dialogDelete" max-width="500px">
        <v-card>
          <v-card-title class="font ma-4 pt-6" style="text-align: center">you want to delete this info?
            🗑️</v-card-title>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
              @click="closeDelete">Cancel</v-btn>
            <v-spacer></v-spacer>
            <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
              @click="deleteItemConfirm">OK</v-btn>
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <!--title-->
      <!-- search -->
      <!-- table -->
      <div>
        <v-data-table v-model:page="page" :headers="headers" :items="filteredPromotion" :items-per-page="itemsPerPage">
          <template v-slot:bottom>
            <div class="text-center pt-2">
              <v-pagination v-model="page" :length="pageCount"></v-pagination>
            </div>
          </template>
          <template v-slot:[`item.image`]="{ item }">
            <v-img :src="'http://localhost:3000/images/promotions/' + item.image" width="100" height="100"></v-img>
          </template>
          <!-- <template v-slot:item.actions="{ item }"> -->
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
            <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
          </template>
          <template v-slot:no-data>
            <v-btn color="primary" @click="PromotionStore.getPromotions()">Reset</v-btn>
          </template>
        </v-data-table>
      </div>
    </div>
  </div>

  <promotion-dialog></promotion-dialog>
</template>

<style scoped>
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}

* {
  font-family: 'Kanit';
}
</style>
